summaryrefslogtreecommitdiffstats
path: root/meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env
diff options
context:
space:
mode:
authorTudor Florea <tudor.florea@enea.com>2014-10-16 03:05:19 +0200
committerTudor Florea <tudor.florea@enea.com>2014-10-16 03:05:19 +0200
commitc527fd1f14c27855a37f2e8ac5346ce8d940ced2 (patch)
treebb002c1fdf011c41dbd2f0927bed23ecb5f83c97 /meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env
downloadpoky-daisy-140929.tar.gz
initial commit for Enea Linux 4.0-140929daisy-140929
Migrated from the internal git server on the daisy-enea-point-release branch Signed-off-by: Tudor Florea <tudor.florea@enea.com>
Diffstat (limited to 'meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env')
-rwxr-xr-xmeta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env192
1 files changed, 192 insertions, 0 deletions
diff --git a/meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env b/meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env
new file mode 100755
index 0000000000..7e4dbc414e
--- /dev/null
+++ b/meta/recipes-devtools/icecc-create-env/icecc-create-env/icecc-create-env
@@ -0,0 +1,192 @@
1#! /usr/bin/env bash
2# icecc -- A simple distributed compiler system
3#
4# Copyright (C) 2004 by the Icecream Authors
5# GPL
6
7target_files=
8
9is_contained ()
10{
11 case " $target_files " in
12 *" $1 "* ) return 0 ;;
13 *"=$1 "* ) return 0;;
14 * ) return 1 ;;
15 esac
16}
17
18add_file ()
19{
20 local name="$1"
21 local path="$1";
22 if test -n "$2"; then
23 name="$2"
24 fi
25 test -z "$name" && return
26 # ls -H isn't really the same as readlink, but
27 # readlink is not portable enough.
28 path=`ls -H $path`
29 toadd="$name=$path"
30 is_contained "$toadd" && return
31 if test -z "$silent"; then
32 echo "adding file $toadd"
33 fi
34 target_files="$target_files $toadd"
35 if test -x "$path"; then
36 # Only call ldd when it makes sense
37 if file -L "$path" | grep 'ELF' > /dev/null 2>&1; then
38 if ! file -L "$path" | grep 'static' > /dev/null 2>&1; then
39 # ldd now outputs ld as /lib/ld-linux.so.xx on current nptl based glibc
40 # this regexp parse the outputs like:
41 # ldd /usr/bin/gcc
42 # linux-gate.so.1 => (0xffffe000)
43 # libc.so.6 => /lib/tls/libc.so.6 (0xb7e81000)
44 # /lib/ld-linux.so.2 (0xb7fe8000)
45 # covering both situations ( with => and without )
46 for lib in `ldd "$path" | sed -n 's,^[^/]*\(/[^ ]*\).*,\1,p'`; do
47 test -f "$lib" || continue
48 # Check wether the same library also exists in the parent directory,
49 # and prefer that on the assumption that it is a more generic one.
50 local baselib=`echo "$lib" | sed 's,\(/[^/]*\)/.*\(/[^/]*\)$,\1\2,'`
51 test -f "$baselib" && lib=$baselib
52 add_file "$lib"
53 done
54 fi
55 fi
56 fi
57}
58
59# backward compat
60if test "$1" = "--respect-path"; then
61 shift
62fi
63
64#add a --silent switch to avoid "broken pipe" errors when calling this scipt from within OE
65if test "$1" = "--silent"; then
66 silent=1
67 shift
68fi
69
70
71added_gcc=$1
72shift
73added_gxx=$1
74shift
75added_as=$1
76shift
77archive_name=$1
78
79if test -z "$added_gcc" || test -z "$added_gxx" ; then
80 echo "usage: $0 <gcc_path> <g++_path>"
81 exit 1
82fi
83
84if ! test -x "$added_gcc" ; then
85 echo "'$added_gcc' is no executable."
86 exit 1
87fi
88
89if ! test -x "$added_gxx" ; then
90 echo "'$added_gcc' is no executable."
91 exit 1
92fi
93
94
95
96add_file $added_gcc /usr/bin/gcc
97add_file $added_gxx /usr/bin/g++
98
99if test -z "$added_as" ; then
100 add_file /usr/bin/as /usr/bin/as
101else
102 if ! test -x "$added_as" ; then
103 echo "'$added_as' is no executable."
104 exit 1
105 fi
106
107 add_file $added_as /usr/bin/as
108fi
109
110add_file `$added_gcc -print-prog-name=cc1` /usr/bin/cc1
111add_file `$added_gxx -print-prog-name=cc1plus` /usr/bin/cc1plus
112specfile=`$added_gcc -print-file-name=specs`
113if test -n "$specfile" && test -e "$specfile"; then
114 add_file "$specfile"
115fi
116
117ltofile=`$added_gcc -print-prog-name=lto1`
118pluginfile="${ltofile%lto1}liblto_plugin.so"
119if test -r "$pluginfile"
120then
121 add_file $pluginfile ${pluginfile#*usr}
122 add_file $pluginfile /usr${pluginfile#*usr}
123fi
124
125tempdir=`mktemp -d /tmp/iceccenvXXXXXX`
126new_target_files=
127for i in $target_files; do
128 case $i in
129 *=/*)
130 target=`echo $i | cut -d= -f1`
131 path=`echo $i | cut -d= -f2`
132 ;;
133 *)
134 path=$i
135 target=$i
136 ;;
137 esac
138 mkdir -p $tempdir/`dirname $target`
139 cp -p $path $tempdir/$target
140 if test -f $tempdir/$target -a -x $tempdir/$target; then
141 strip -s $tempdir/$target 2>/dev/null
142 fi
143 target=`echo $target | cut -b2-`
144 new_target_files="$new_target_files $target"
145done
146
147#sort the files
148target_files=`for i in $new_target_files; do echo $i; done | sort`
149
150#test if an archive name was supplied
151#if not use the md5 of all files as the archive name
152if test -z "$archive_name"; then
153 md5sum=NONE
154 for file in /usr/bin/md5sum /bin/md5 /usr/bin/md5; do
155 if test -x $file; then
156 md5sum=$file
157 break
158 fi
159 done
160
161 #calculate md5 and use it as the archive name
162 archive_name=`for i in $target_files; do test -f $tempdir/$i && $md5sum $tempdir/$i; done | sed -e 's/ .*$//' | $md5sum | sed -e 's/ .*$//'`.tar.gz || {
163 if test -z "$silent"; then
164 echo "Couldn't compute MD5 sum."
165 fi
166 exit 2
167 }
168 mydir=`pwd`
169else
170 mydir="`dirname "$archive_name"`"
171
172 #check if we have a full path or only a filename
173 if test "$mydir" = "." ; then
174 mydir=`pwd`
175 else
176 mydir=""
177 fi
178fi
179
180if test -z "$silent"; then
181echo "creating $archive_name"
182fi
183
184cd $tempdir
185tar -czhf "$mydir/$archive_name" $target_files || {
186 if test -z "$silent"; then
187 echo "Couldn't create archive"
188 fi
189 exit 3
190}
191cd ..
192rm -rf $tempdir